package org.eclipse.demo.cheatsheets.search.internal.slave;

import java.util.Set;

import org.eclipse.platform.discovery.core.api.IContributedAction;
import org.eclipse.platform.discovery.core.api.ISearchFavoritesMasterController;
import org.eclipse.platform.discovery.util.api.longop.ILongOperationRunner;

/**
 * Action for deleting a cheat sheet from the search favorites view
 * @author danail
 *
 */
public class DeleteFromFavoritesAction implements IContributedAction
{
	public static final String ACTION_ID = DeleteFromFavoritesAction.class.getName();
	
	private final ISearchFavoritesMasterController controller;

	public DeleteFromFavoritesAction(final ISearchFavoritesMasterController controller)
	{
		this.controller = controller;
	}
	
	@Override
	public void perform(ILongOperationRunner operationRunner, Set<Object> selectedObjects)
	{
		controller.deleteItems(selectedObjects);
	}

	@Override
	public Object getActionId()
	{
		return ACTION_ID;
	}

}
