package org.eclipse.demo.cheatsheets.search.internal.slave;

import java.util.Set;

import org.eclipse.platform.discovery.core.api.IContributedAction;
import org.eclipse.platform.discovery.core.api.ISearchFavoritesMasterController;
import org.eclipse.platform.discovery.core.api.ISearchFavoritesSlaveController;

/**
 * The slave controller for the search favorites customization.
 * @author danail
 *
 */
public class FavoritesSlaveController extends CSSlaveController implements ISearchFavoritesSlaveController
{
	private ISearchFavoritesMasterController controller;

	@Override
	public void setMasterController(ISearchFavoritesMasterController masterController)
	{
		this.controller = masterController;
	}
	
	@Override
	public Set<IContributedAction> createActions()
	{
		final Set<IContributedAction> actions = super.createActions();
		actions.add(new DeleteFromFavoritesAction(controller));
		
		return actions;
	}
}
