/*******************************************************************************
 * Copyright (c) 2008 Hallvard Traetteberg.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Hallvard Traetteberg - initial API and implementation
 ******************************************************************************/
package org.eclipse.e4.tm.builder;

import junit.framework.Assert;

import org.eclipse.e4.tm.widgets.AbstractComposite;
import org.eclipse.e4.tm.widgets.Control;
import org.eclipse.e4.tm.widgets.Label;
import org.eclipse.e4.tm.widgets.WidgetsPackage;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Composite;

public class ControlReparentTest extends TmResourceTestCase {

	public void testControlReparent() {
		Composite composite = getChild(0, Composite.class);
		EObject eComposite = getRoot(WidgetsPackage.eINSTANCE.getComposite());

		AbstractComposite<?> eComp1 = (AbstractComposite<?>)getChild(eComposite, 0, WidgetsPackage.eINSTANCE.getComposite());
		Composite comp1 = getChild(composite, 0, Composite.class);
		Assert.assertEquals(2, comp1.getChildren().length);

		AbstractComposite<?> eComp2 = (AbstractComposite<?>)getChild(eComposite, 1, WidgetsPackage.eINSTANCE.getComposite());
		Composite comp2 = getChild(composite, 1, Composite.class);
		Assert.assertEquals(0, comp2.getChildren().length);

//		Label eLabel1 = (Label)getChild(eComp1, 0, WidgetsPackage.eINSTANCE.getLabel());
		org.eclipse.swt.widgets.Control label1 = getChild(comp1, 0, org.eclipse.swt.custom.CLabel.class);
		Label eLabel2 = (Label)getChild(eComp1, 1, WidgetsPackage.eINSTANCE.getLabel());
		org.eclipse.swt.widgets.Control label2 = getChild(comp1, 1, org.eclipse.swt.custom.CLabel.class);

		eLabel2.setComposite((AbstractComposite<Control>)eComp2);

		Assert.assertTrue(label1.isDisposed());
		Assert.assertTrue(label2.isDisposed());

		Assert.assertEquals(1, comp1.getChildren().length);
		Assert.assertEquals(1, comp2.getChildren().length);

		Assert.assertEquals(1, comp1.getChildren().length);
		org.eclipse.swt.widgets.Control label12 = getChild(comp1, 0, org.eclipse.swt.custom.CLabel.class);
		Assert.assertNotNull(label12);
		Assert.assertEquals(1, comp2.getChildren().length);
		org.eclipse.swt.widgets.Control label22 = getChild(comp2, 0, org.eclipse.swt.custom.CLabel.class);
		Assert.assertNotNull(label22);

		Assert.assertNotSame(label1, label12);
		Assert.assertNotSame(label2, label22);
	}

	public static void main(String[] args) {
		TmResourceTestCase.doRun(ControlReparentTest.class);
	}
}
