/*******************************************************************************
 * Copyright (c) 2008 Hallvard Traetteberg.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Hallvard Traetteberg - initial API and implementation
 ******************************************************************************/
package org.eclipse.e4.tm.builder;

import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Widget;


public class EventHelper {

	public static void sendEvent(Widget widget, Event event) {
		Listener[] listeners = widget.getListeners(event.type);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].handleEvent(event);
		}
	}

	public static void sendEvent(Widget widget, int eventType) {
		Event event = new Event();
		event.widget = widget;
		event.type = eventType;
		event.display = widget.getDisplay();
		EventHelper.sendEvent(widget, event);
	}
}
