/*******************************************************************************
 * Copyright (c) 2008 Hallvard Traetteberg.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Hallvard Traetteberg - initial API and implementation
 ******************************************************************************/
package org.eclipse.e4.tm.builder.widgets;

import junit.framework.Assert;

import org.eclipse.e4.tm.builder.EventHelper;
import org.eclipse.e4.tm.builder.TmModelTest;
import org.eclipse.e4.tm.builder.TmTestCase;
import org.eclipse.e4.tm.util.UtilPackage;
import org.eclipse.e4.tm.widgets.WidgetsFactory;
import org.eclipse.e4.tm.widgets.WidgetsPackage;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;

public class CheckBoxTest extends TmModelTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testButton() {
		WidgetsPackage widgetsPackage = WidgetsPackage.eINSTANCE;
		EObject eButton = WidgetsFactory.eINSTANCE.create(widgetsPackage.getCheckBox());
		String buttonText = "A button";
		eButton.eSet(UtilPackage.eINSTANCE.getLabeled_Text(), buttonText);

		builder.build(eButton, getTopLevel());

		Button button = getChild(0, Button.class);
		Assert.assertNotNull(button);
		testStyle(button, SWT.CHECK);
		Assert.assertEquals(buttonText, button.getText());
		Assert.assertEquals(setFeature(eButton, "text", "x" + buttonText), button.getText());

		button.setSelection(true);
		EventHelper.sendEvent(button, SWT.Selection);
		Assert.assertNotNull(getFeature(eButton, "selectionEvent"));
		Assert.assertTrue((Boolean)getFeature(eButton, "selection"));
	}

	public static void main(String[] args) {
		TmTestCase.doRun(CheckBoxTest.class);
	}
}
