/*******************************************************************************
 * Copyright (c) 2008 Hallvard Traetteberg.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Hallvard Traetteberg - initial API and implementation
 ******************************************************************************/
package org.eclipse.e4.tm.builder.widgets;

import junit.framework.Assert;
import org.eclipse.e4.tm.builder.TmTestCase;
import org.eclipse.e4.tm.widgets.WidgetsFactory;
import org.eclipse.e4.tm.widgets.WidgetsPackage;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Composite;

public class CompositeTest extends AbstractCompositeTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testComposite() {
		WidgetsPackage widgetsPackage = WidgetsPackage.eINSTANCE;
		EObject eComp = WidgetsFactory.eINSTANCE.create(widgetsPackage.getComposite());
		String labelText = "A label";
		EObject[] eLabels = fillWithELabels(eComp, labelText, 5);

		builder.build(eComp, getTopLevel());

		Composite comp = getChild(0, Composite.class);
		Assert.assertNotNull(comp);
		testLabels(comp, eLabels, labelText, false);
	}

	public static void main(String[] args) {
		TmTestCase.doRun(CompositeTest.class);
	}
}
