/*******************************************************************************
 * Copyright (c) 2008 Hallvard Traetteberg.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Hallvard Traetteberg - initial API and implementation
 ******************************************************************************/
package org.eclipse.e4.tm.builder.widgets;

import junit.framework.Assert;

import org.eclipse.e4.tm.builder.TmTestCase;
import org.eclipse.e4.tm.util.UtilPackage;
import org.eclipse.e4.tm.widgets.WidgetsFactory;
import org.eclipse.e4.tm.widgets.WidgetsPackage;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Group;

public class GroupBoxTest extends AbstractCompositeTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testGroup() {
		WidgetsPackage widgetsPackage = WidgetsPackage.eINSTANCE;
		EObject eGroup = WidgetsFactory.eINSTANCE.create(widgetsPackage.getGroupBox());
		String labelText = "A label";
		EObject[] eLabels = fillWithELabels(eGroup, labelText, 5);
		String groupText = "A group";
		eGroup.eSet(UtilPackage.eINSTANCE.getLabeled_Text(), groupText);

		builder.build(eGroup, getTopLevel());

		Group group = getChild(0, Group.class);
		Assert.assertNotNull(group);
		testLabels(group, eLabels, labelText, false);
		Assert.assertEquals(groupText, group.getText());
		Assert.assertEquals(setFeature(eGroup, "text", "x" + groupText), group.getText());
	}

	public static void main(String[] args) {
		TmTestCase.doRun(GroupBoxTest.class);
	}
}
