/*******************************************************************************
 * Copyright (c) 2008 Hallvard Traetteberg.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Hallvard Traetteberg - initial API and implementation
 ******************************************************************************/
package org.eclipse.e4.tm.builder.widgets;

import junit.framework.Assert;

import org.eclipse.e4.tm.builder.TmModelTest;
import org.eclipse.e4.tm.builder.TmTestCase;
import org.eclipse.e4.tm.util.UtilPackage;
import org.eclipse.e4.tm.widgets.WidgetsFactory;
import org.eclipse.e4.tm.widgets.WidgetsPackage;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.custom.CLabel;

public class LabelTest extends TmModelTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testLabel() {
		WidgetsPackage widgetsPackage = WidgetsPackage.eINSTANCE;
		EObject eLabel = WidgetsFactory.eINSTANCE.create(widgetsPackage.getLabel());
		String labelText = "A label";
		eLabel.eSet(UtilPackage.eINSTANCE.getLabeled_Text(), labelText);

		builder.build(eLabel, getTopLevel());

		CLabel label = getChild(0, CLabel.class);
		Assert.assertNotNull(label);
		Assert.assertEquals(labelText, label.getText());
		Assert.assertEquals(setFeature(eLabel, "text", "x" + labelText), label.getText());
	}

	public static void main(String[] args) {
		TmTestCase.doRun(LabelTest.class);
	}
}
