/*******************************************************************************
 * Copyright (c) 2010 SAP AG, Walldorf.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SAP AG - initial API and implementation
 *******************************************************************************/
package org.eclipse.platform.discovery.runtime.internal.xp.impl;

import java.util.List;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.platform.discovery.runtime.internal.xp.IGenericXpParser;


/**
 * Implementation of the {@link IGenericXpParser} interface
 * 
 * @author Danail Branekov
 */
public class GenericXpParser implements IGenericXpParser
{
	public List<IConfigurationElement> getConfigurationElements(final IExtensionRegistry extRegistry, final String xpId, final String elementName)
	{
		return createParser(extRegistry, xpId, elementName).getConfigurationElements();
	}

	private AbstractExtensionPointParserImpl createParser(final IExtensionRegistry extRegistry, final String xpId, final String elementName)
	{
		return new AbstractExtensionPointParserImpl(extRegistry, xpId, elementName);
	}

	private class AbstractExtensionPointParserImpl extends AbstractExtensionPointParser
	{
		public AbstractExtensionPointParserImpl(IExtensionRegistry extRegistry, String xpId, String elementName)
		{
			super(extRegistry, xpId, elementName);
		}

		public List<IConfigurationElement> getConfigurationElements()
		{
			return super.getConfigurationElements();
		}
	}
}
